/*
 * Copyright (c) 2007 Brett Zamir
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * */

window.addEventListener("load", function(e) { charrefunicode.onLoad(e); }, false);

var charrefunicode = {
  onLoad: function() {
    // initialization code
    this.initialized = true;
    document.getElementById("contentAreaContextMenu")
		.addEventListener("popupshowing", function(e) { charrefunicode.showContextMenu(e); }, false);	
  },

  showContextMenu: function(event) {
    // show or hide the menuitem based on what the context menu is on
    // see http://kb.mozillazine.org/Adding_items_to_menus
      var cm = gContextMenu;
	  for (var i=1; i < 11; i++) { // Hide all subitems except for the launcher if no text is selected (could get rid of this (always showing the subitems) and just use the clipboard contents)
		document.getElementById("context-charrefunicode"+i).hidden = !cm.isTextSelected;
      }
  },
  
  onMenuItemCommand: function(e) {
	// If no value selected (and not the plain launcher), could (after changing showContextMenu method above), check the clipboard for a value (not currently implemented)
	var toconvert = content.window.getSelection();

/* Could use this to get the source code of the current document, but currently the serializer will convert tags to upper case (and reduce to canonical XML too?): http://wiki.mozilla.org/Firefox:3.0_DOM_Case_Sensitivity
	var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);
	var serialize = new XMLSerializer();
	var toconvert = serialize.serializeToString(mainWindow.content.document);
*/

	var dialog = window.openDialog("chrome://charrefunicode/content/uresults.xul","unicoderesults",
                    "chrome, resizable, scrollbars, centerscreen",
									 /* Scrollbars don't seem to work on a Mac at least */
									 toconvert, e.target.id);
	dialog.focus();
  }

};
