// Todo: Can textboxes or at least the table be made expand with the window being expanded? (flex?)
// Could consolidate HTML conversion functions here into one function
// Could use own functions to simplify DOM calls

window.addEventListener("load", function(e) {Unicodecharref.initialize(e); }, false);
/* The following works, but if used will not allow user to cancel to get out of the current window size and will go back to the last window size; if use this, don't need code in "doOk" (besides return true)
window.addEventListener(
						"resize", 
						function(e) {
							Unicodecharref.prefs.
								setIntPref("extensions.charrefunicode.window.outer.height", 
									window.outerHeight);
							Unicodecharref.prefs.
								setIntPref("extensions.charrefunicode.window.outer.width", 
									window.outerWidth);
						},
						false);
*/

var Unicodecharref = {
	initialize: function(e) {
		// These defaults are necessary for the sake of the options URL (when called from addons menu)
		var toconvert = '';
		var targetid = 'context-launchunicode';		
		if (window.arguments !== undefined) {
			toconvert = window.arguments[0].toString(); // Need the conversion to string since content.window.getSelection() passed here gives an object, unlike the now deprecated content.document.getSelection() which returns a string. (Discovered deprecated status via Console extension: https://addons.mozilla.org/en-US/firefox/addon/1815 )
			targetid = window.arguments[1];
		}
//		alert(toconvert+':'+targetid);

		this.strbundle = document.getElementById("charrefunicode-strings");
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].
						getService(Components.interfaces.nsIPrefService);
		this.branch = this.prefs.getBranch("extensions.charrefunicode.");

		
		if (this.prefs.getBoolPref("extensions.charrefunicode.asciiLt128")) {
			document.getElementById("extensions.charrefunicode.asciiLt128").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.xhtmlentmode")) {
			document.getElementById("extensions.charrefunicode.xhtmlentmode").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.hexstyleLwr")) {
			document.getElementById("extensions.charrefunicode.hexstyleLwr").selectedIndex = 0;
		}
		else {
			document.getElementById("extensions.charrefunicode.hexstyleLwr").selectedIndex = 1;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.hexLettersUpper")) {
			document.getElementById("extensions.charrefunicode.hexLettersUpper").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.xmlentkeep")) {
			document.getElementById("extensions.charrefunicode.xmlentkeep").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampkeep")) {
			document.getElementById("extensions.charrefunicode.ampkeep").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			document.getElementById("extensions.charrefunicode.ampspace").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.appendtohtmldtd")) {
			document.getElementById("extensions.charrefunicode.appendtohtmldtd").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.hexyes")) {
			document.getElementById("extensions.charrefunicode.hexyes").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.decyes")) {
			document.getElementById("extensions.charrefunicode.decyes").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.unicodeyes")) {
			document.getElementById("extensions.charrefunicode.unicodeyes").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.middleyes")) {
			document.getElementById("extensions.charrefunicode.middleyes").checked = true;
		}
		if (this.prefs.getBoolPref("extensions.charrefunicode.buttonyes")) {
			document.getElementById("extensions.charrefunicode.buttonyes").checked = true;
		}

		if (this.prefs.getCharPref("extensions.charrefunicode.xstyle") === 'x') {
			document.getElementById("extensions.charrefunicode.xstyle").checked = true;
		}

		this.resizecells(true, 0); // Set the size per the prefs (don't increase or decrease the value)
		
		document.getElementById("rowsset").value = this.prefs.getIntPref("extensions.charrefunicode.tblrowsset");
		document.getElementById("colsset").value = this.prefs.getIntPref("extensions.charrefunicode.tblcolsset");

		var rcsize_converted_cols = this.prefs.getIntPref("extensions.charrefunicode.rcsize.converted.cols");
		var rcsize_converted_rows = this.prefs.getIntPref("extensions.charrefunicode.rcsize.converted.rows");
		var rcsize_toconvert_rows = this.prefs.getIntPref("extensions.charrefunicode.rcsize.toconvert.rows");
		document.getElementById("converted").setAttribute("cols", rcsize_converted_cols);
		document.getElementById("converted").setAttribute("rows", rcsize_converted_rows);
		document.getElementById("toconvert").setAttribute("rows", rcsize_toconvert_rows);

		// Save copies in case decide to reset later (i.e., not append to HTML entities, then wish to append to them again)
		// Do the following since can't copy arrays by value
		// Must define outside of copyarray function
		this.origents = new Array();
		this.origcharrefs = new Array();
		this.orignewents = new Array();
		this.orignewcharrefs = new Array();
		
		this.copyarray(this.ents, this.origents);
		this.copyarray(this.charrefs, this.origcharrefs);
		this.copyarray(this.newents, this.orignewents);
		this.copyarray(this.newcharrefs, this.orignewcharrefs);

		
		var DTDtxtbxval = this.branch.getComplexValue("DTDtextbox",
					Components.interfaces.nsIPrefLocalizedString).data;
		
		document.getElementById("DTDtextbox").value = DTDtxtbxval;
		this.registerDTD();

		//		toconvert = charreftoconvert.replace(/\n/g, " ");
		document.getElementById("toconvert").value = toconvert;

		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		
		// Detect which context menu item was selected:
		var out, converttypeid;
		switch (targetid) {
			case "context-charrefunicode1":
				out = this.charref2unicodeval(toconvert, document.getElementById('b1'));
				break;
			case "context-charrefunicode2":
				out = this.charref2htmlentsval(toconvert, document.getElementById('b2'));
				break;
			case "context-charrefunicode3":
				out = this.unicode2charrefDecval(toconvert, document.getElementById('b3'));
				break;
			case "context-charrefunicode4":
				out = this.unicode2charrefHexval(toconvert, document.getElementById('b4'));
				break;
			case "context-charrefunicode5":
				out = this.unicode2htmlentsval(toconvert, document.getElementById('b5'));
				break;
			case "context-charrefunicode6":
				out = this.htmlents2charrefDecval(toconvert, document.getElementById('b6'));
				break;
			case "context-charrefunicode7":
				out = this.htmlents2charrefHexval(toconvert, document.getElementById('b7'));
				break;
			case "context-charrefunicode8":
				out = this.htmlents2unicodeval(toconvert, document.getElementById('b8'));
				break;
			case "context-charrefunicode9":
				out = this.hex2decval(toconvert, document.getElementById('b9'));
				break;
			case "context-charrefunicode10":
				out = this.dec2hexval(toconvert, document.getElementById('b10'));
				break;
			case "context-launchunicode":
			default:
				out = ''; // Plain launcher with no values sent
				break;
		}

		this.printunicode();
		this.tblfontsize(0); // Draw with the preferences value
		
		var menuitems = document.getElementsByTagNameNS(this.xulns, "menuitem");

		for (var i=0; i < menuitems.length; i++) {
			menuitems[i].addEventListener(
				"command", 
				function(e){
					var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
					temp1.data = e.target.value;
					Unicodecharref.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
					Unicodecharref.printunicode();
				}, 
				false
			);
		}

		document.getElementById("converted").value = out;
		/*
		if (converttypeid != 0) {
			document.getElementById(converttypeid).className='buttonactive';	
		}
		*/

		// Set window size to that set last time hit "ok"
		var outerh = this.prefs.getIntPref("extensions.charrefunicode.window.outer.height");
		var outerw = this.prefs.getIntPref("extensions.charrefunicode.window.outer.width");
		if (outerh > 0) {
			window.outerHeight = outerh;
		}
		if (outerw > 0) {
			window.outerWidth = outerw;
		}
	},
	copyarray: function(a, b) {
		b.length = 0;
		for (var i = 0; i < a.length; i++) {
			b[i] = a[i];
		}
	},
	fixFromCharCode: function(codePt) {
		// need to fix all of the fromCharCode's (JS using older Unicode standard)
		if (codePt > 0xFFFF) {
			// alert(codePt);
			codePt -= 0x10000;
			return String.fromCharCode(0xD800 + (codePt >> 10), 0xDC00 + (codePt & 0x3FF));
		}
		else {
			return String.fromCharCode(codePt);
		}
	},
	setprefs: function(e) {
		switch (e.target.nodeName) {
			case "checkbox":
				// Apparently hasn't changed yet, so use the opposite
				this.prefs.setBoolPref(e.target.id, Boolean(!e.target.checked));
				break;
			case "radio":
				var radioid;
				var result = e.target.id.match(/^_([0-9])+;(.*)$/);
				if (result !== null) {
					radioid = result[2]; // Extract preference name
					if (result[1] === "1") {
						this.prefs.setBoolPref(radioid, true);
					}
					else {
						this.prefs.setBoolPref(radioid, false);
					}
				}
				break;
			default:
				break;
		}
	},
	resetdefaults: function() {
		/* If make changes here, also change the default/preferences charrefunicode.js file */
		this.prefs.setBoolPref("extensions.charrefunicode.asciiLt128", false);
		this.prefs.setBoolPref("extensions.charrefunicode.xhtmlentmode", false);
		this.prefs.setBoolPref("extensions.charrefunicode.hexstyleLwr", true);
		this.prefs.setBoolPref("extensions.charrefunicode.hexLettersUpper", false);
		this.prefs.setBoolPref("extensions.charrefunicode.xmlentkeep", true);
		this.prefs.setBoolPref("extensions.charrefunicode.ampkeep", true);
		document.getElementById("extensions.charrefunicode.ampkeep").checked = true;
		document.getElementById("extensions.charrefunicode.ampspace").checked = true;
		document.getElementById("extensions.charrefunicode.xmlentkeep").checked = true;
		document.getElementById("extensions.charrefunicode.asciiLt128").checked = false;
		document.getElementById("extensions.charrefunicode.xhtmlentmode").checked = false;
		document.getElementById("extensions.charrefunicode.hexstyleLwr").selectedIndex = 0;
		document.getElementById("extensions.charrefunicode.hexLettersUpper").checked = false;
		
		this.prefs.setIntPref("extensions.charrefunicode.fsizetextbox", 13);
		this.fsizetextbox(0);
		
		this.prefs.setIntPref("extensions.charrefunicode.rcsize.converted.cols", 60);
		this.prefs.setIntPref("extensions.charrefunicode.rcsize.converted.rows", 20);
		this.prefs.setIntPref("extensions.charrefunicode.rcsize.toconvert.rows", 2);
		document.getElementById("converted").setAttribute("cols", 60);
		document.getElementById("converted").setAttribute("rows", 20);
		document.getElementById("toconvert").setAttribute("rows", 2);

		this.prefs.setBoolPref("extensions.charrefunicode.appendtohtmldtd", true);
		document.getElementById("extensions.charrefunicode.appendtohtmldtd").checked = true;
		
		
		/*
		Easy enough to manually remove DTD -- wouldn't want to lose that data
		var temp0 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp0.data = "";
		this.prefs.setComplexValue("extensions.charrefunicode.DTDtextbox", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp0);
		
		document.getElementById("DTDtextbox").value = "";	
		*/
		
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = "#0";
		this.prefs.setComplexValue("extensions.charrefunicode.startset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1); // Don't really need to reset since user can't currently change this (only for blank string entry)
		
		var temp2 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp2.data = "#0";
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp2);
		
		// These get activated in this.printunicode() below
		this.prefs.setIntPref("extensions.charrefunicode.tblrowsset", 4);
		document.getElementById("rowsset").value = 4;
		this.prefs.setIntPref("extensions.charrefunicode.tblcolsset", 3);
		document.getElementById("colsset").value = 3;
		
		this.prefs.setBoolPref("extensions.charrefunicode.hexyes", true);
		document.getElementById("extensions.charrefunicode.hexyes").checked = true;
		this.prefs.setBoolPref("extensions.charrefunicode.decyes", true);
		document.getElementById("extensions.charrefunicode.decyes").checked = true;
		this.prefs.setBoolPref("extensions.charrefunicode.unicodeyes", true);
		document.getElementById("extensions.charrefunicode.unicodeyes").checked = true;
		this.prefs.setBoolPref("extensions.charrefunicode.middleyes", false);
		document.getElementById("extensions.charrefunicode.middleyes").checked = false;
		
		this.prefs.setCharPref("extensions.charrefunicode.xstyle", "x");
		document.getElementById("extensions.charrefunicode.xstyle").checked = true;
		
		this.prefs.setBoolPref("extensions.charrefunicode.buttonyes", true);
		document.getElementById("extensions.charrefunicode.buttonyes").checked = true;
		
		this.prefs.setIntPref("extensions.charrefunicode.tblfontsize", 13);
		this.resizecells(true, 0);
		
		this.printunicode();
		this.prefs.setIntPref("extensions.charrefunicode.window.outer.height", 0);
		this.prefs.setIntPref("extensions.charrefunicode.window.outer.width", 0);
	},
	classchange: function(el) {
		try {
			var xpathresultobj = document.evaluate("//*[@class='buttonactive']", document.documentElement, function() {return null}, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
		}
		catch (e) {
			alert(e);
		}

		if (xpathresultobj.singleNodeValue !== null) {
		// This is apparently necessary as the XPath expression does not seem to me to be able to allow manipulation of the original node
			document.getElementById(xpathresultobj.singleNodeValue.id).className='reconvert';
		}
		el.className="buttonactive";
		/*
		// If want this loop (set type above to ORDERED_NODE_SNAPSHOT_TYPE)
		for (var i = 0; i < xpathresultobj.snapshotLength; i++) {
			xpathresultobj.snapshotitem(i).classname='reconvert';
		}
		*/
	},
	charref2unicodeval: function(out, el) {
		this.classchange(el);
		out = out.replace(this.decim, function(match, match1){return Unicodecharref.fixFromCharCode(match1);});
		out = out.replace(this.hexadec, function(match, match1){return Unicodecharref.fixFromCharCode(parseInt("0x"+match1, 16));});
		return out;
	},
  	charref2htmlentsval: function(out, el) {
		this.classchange(el);
		var xhtmlentmode = this.prefs.getBoolPref("extensions.charrefunicode.xhtmlentmode"); // If true, should allow conversion to &apos;

		out = out.replace(this.decim, function(match, match1){
		
			var matched = Unicodecharref.charrefs.indexOf(parseInt(match1, 10));

			if (matched !== -1 && (matched != (98 + this.shiftcount) || xhtmlentmode)) {
				return "&"+Unicodecharref.ents[matched]+";";
			}
			else return match;
			}
		);

		out = out.replace(this.hexadec, function(match, match1){
			var matched = Unicodecharref.charrefs.indexOf(parseInt("0x"+match1, 16));
			if (matched !== -1 && (matched != (98 + this.shiftcount) || xhtmlentmode)) {
				return "&"+Unicodecharref.ents[matched]+";";
			}
			else return match;
			}
		);
		return out;
	},
  
	unicode2charrefDecval: function(unicodetoconvert, el) {
		this.classchange(el);
		var out = ''; 
		for (var i=0; i < unicodetoconvert.length; i++) {
			var temp = unicodetoconvert.charCodeAt(i);
			if (temp >= 128 || this.prefs.getBoolPref("extensions.charrefunicode.asciiLt128")) { /* replace this 'if' condition and remove the 'else' if also want ascii */
				out += '&#' + temp + ';';
			}
			else {
				out += unicodetoconvert.charAt(i);
			}
		}
		return out;
	},
  
	unicode2charrefHexval: function(unicodetoconvert, el) {
		this.classchange(el);
		var out = '';
		for (var i=0; i < unicodetoconvert.length; i++) {
			var temp = unicodetoconvert.charCodeAt(i);
			var xstyle = 'x';
			if (!this.prefs.getBoolPref("extensions.charrefunicode.hexstyleLwr")) {
				xstyle = 'X';
			}

			if (temp >= 128 || this.prefs.getBoolPref("extensions.charrefunicode.asciiLt128")) { /* replace this 'if' condition and remove the 'else' if also want ascii */
				var hexletters = temp.toString(16);
				if (this.prefs.getBoolPref("extensions.charrefunicode.hexLettersUpper")) {
					hexletters = hexletters.toUpperCase();
				}
				out += '&#' + xstyle + hexletters + ';';
			}
			else {
				out += unicodetoconvert.charAt(i);
			}
		}
		return out;
	},
  
	unicode2htmlentsval: function(unicodetoconvert, el) {
		this.classchange(el);
		RegExp.escape = (function() {
				var specials = [
					'/', '.', '*', '+', '?', '|',
					'(', ')', '[', ']', '{', '}', '\\'
				];

				sRE = new RegExp(
					'(\\' + specials.join('|\\') + ')', 'g'
				);
  
				return function(text) {
					return text.replace(sRE, '\\$1');
				}
		})();
		for (var i=0; i < Unicodecharref.newents.length; i++) {
			/* From: Comment of Mark Wubben: http://simonwillison.net/2006/Jan/20/escape/  */

			var regex = new RegExp(RegExp.escape(this.newcharrefs[i]), "gm"); // Escaping necessary for custom entities added via the DTD
			unicodetoconvert = unicodetoconvert.replace(regex, "&"+this.newents[i]+";");
		}			

		var out = '';
		var xhtmlentmode = this.prefs.getBoolPref("extensions.charrefunicode.xhtmlentmode"); // If true, should allow conversion to &apos;
		var ampkeep = this.prefs.getBoolPref("extensions.charrefunicode.ampkeep"); // If true, will not convert "&" to "&amp;"

		for (var i=0; i < unicodetoconvert.length; i++) {
	
			var charcodeati = unicodetoconvert.charCodeAt(i);
			var tempcharref = this.charrefs.indexOf(charcodeati);
	
			if (tempcharref !== -1 && (tempcharref != (98 + this.shiftcount) || xhtmlentmode) && (tempcharref != (99  + this.shiftcount) || !ampkeep)) {
				out += "&"+this.ents[tempcharref]+";";
			}
			else {
				out += unicodetoconvert.charAt(i);
			}
		}

		return out;
	},

	htmlents2charrefDecval: function(out, el) {
		this.classchange(el);
		var xmlentkeep = this.prefs.getBoolPref("extensions.charrefunicode.xmlentkeep"); // If true, don't convert &apos;, &quot;, &lt;, &gt;, and &amp;
		out = out.replace(this.htmlent, function(match, match1){
		
			if (!xmlentkeep || 
				(match1 !== "apos" && match1 !== "quot" && match1 !== "lt"
					&& match1 !== "gt" && match1 !== "amp")) {
				if (Unicodecharref.newents.indexOf(match1) !== -1) { // If recognized multiple char ent. (won't convert these to decimal)
					var ret = Unicodecharref.newcharrefs[Unicodecharref.newents.indexOf(match1)];
					return ret;
				}
				else if (Unicodecharref.ents.indexOf(match1) !== -1) { // If recognized single char. ent.
					return "&#"+Unicodecharref.charrefs[Unicodecharref.ents.indexOf(match1)]+";";
				}
				else { // If unrecognized
					return "&"+match1+";";
				}
			}
			else { // If keeping predefined XML entities (and this is one)
				return "&"+match1+";";
			}
		
			}
		);
		return out;
	},
  
	htmlents2charrefHexval: function(out, el) {
		this.classchange(el);
		var xstyle = 'x';
		if (!this.prefs.getBoolPref("extensions.charrefunicode.hexstyleLwr")) {
			xstyle = 'X';
		}
		var xmlentkeep = this.prefs.getBoolPref("extensions.charrefunicode.xmlentkeep"); // If true, don't convert &apos;, &quot;, &lt;, &gt;, and &amp;
		out = out.replace(this.htmlent, function(match, match1){
	
			if (!xmlentkeep || (match1 !== "apos" && match1 !== "quot" && match1 !== "lt" && match1 !== "gt" && match1 !== "amp")) {
				var b = Unicodecharref.charrefs[Unicodecharref.ents.indexOf(match1)];
				var c = Unicodecharref.newents.indexOf(match1);

				if (c !== -1) { // If recognized multiple char. ent. (won't convert these to hexadecimal)
					var ret = Unicodecharref.newcharrefs[c];
					return ret;
				}
				else if (Unicodecharref.ents.indexOf(match1) !== -1) { // If recognized single char. ent.
					var hexletters = b.toString(16);
					if (Unicodecharref.prefs.getBoolPref("extensions.charrefunicode.hexLettersUpper")) {
						hexletters = hexletters.toUpperCase();
					}
					return "&#"+xstyle+hexletters+";";
				}
				else { // If unrecognized ent.
					return "&"+match1+";";
				}
			}
			else { // If keeping predefined XML entities (and this is one)
				return "&"+match1+";";
			}
			}
		);
		return out;
	},

	htmlents2unicodeval: function(out, el) {
		this.classchange(el);
		var xmlentkeep = this.prefs.getBoolPref("extensions.charrefunicode.xmlentkeep"); // If true, don't convert &apos;, &quot;, &lt;, &gt;, and &amp;
		out = out.replace(this.htmlent, function(match, match1){
	
			if (!xmlentkeep || (match1 !== "apos" && match1 !== "quot" && match1 !== "lt" && match1 !== "gt" && match1 !== "amp")) {
				var b = Unicodecharref.charrefs[Unicodecharref.ents.indexOf(match1)];
				
				if (Unicodecharref.newents.indexOf(match1) !== -1) { // If recognized multiple char ent.
					var ret = Unicodecharref.newcharrefs[Unicodecharref.newents.indexOf(match1)];
					return ret;
				}
				else if (Unicodecharref.ents.indexOf(match1) !== -1) { // If recognized single char. ent.
					return Unicodecharref.fixFromCharCode(b);
				}
				else { // If unrecognized
					return "&"+match1+";";
				}
			}
			else { // If keeping predefined XML entities (and this is one)
				return "&"+match1+";";
			}
			}
		);
		return out;
	},
  
	hex2decval: function(out, el) {
		this.classchange(el);
		out = out.replace(this.hexadec, function(match, match1){return "&#"+parseInt("0x"+match1, 16)+";";});
		return out;	
	},
	dec2hexval: function(out, el) {
		this.classchange(el);
		var xstyle = 'x';
		if (!this.prefs.getBoolPref("extensions.charrefunicode.hexstyleLwr")) {
			xstyle = 'X';
		}
		out = out.replace(this.decim, function(match, match1){
			var hexletters = Number(match1).toString(16);
			if (Unicodecharref.prefs.getBoolPref("extensions.charrefunicode.hexLettersUpper")) {
				hexletters = hexletters.toUpperCase();
			}
			return "&#"+xstyle+hexletters+";";}
		);
		return out;
	},
  
  
	charref2unicode: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.charref2unicodeval(toconvert, e.target);
		return false;
	},
	charref2htmlents: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.charref2htmlentsval(toconvert, e.target);
		return false;
	},
	unicode2charrefDec: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.unicode2charrefDecval(toconvert, e.target);
		return false;
	},
	unicode2charrefHex: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.unicode2charrefHexval(toconvert, e.target);
		return false;
	},
	unicode2htmlents: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.unicode2htmlentsval(toconvert, e.target);
		return false;
	},
	htmlents2charrefDec: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.htmlents2charrefDecval(toconvert, e.target);
		return false;
	},
	htmlents2charrefHex: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.htmlents2charrefHexval(toconvert, e.target);
		return false;
	},
	htmlents2unicode: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.htmlents2unicodeval(toconvert, e.target);
		return false;
	},
	hex2dec: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.hex2decval(toconvert, e.target);
		return false;
	},
	dec2hex: function(e) {
		var toconvert = document.getElementById("toconvert").value;
		if (this.prefs.getBoolPref("extensions.charrefunicode.ampspace")) {
			toconvert = toconvert.replace(/&([^;\s]*\s)/g, "&amp;$1");
		}
		document.getElementById("converted").value = this.dec2hexval(toconvert, e.target);
		return false;
	},
	printunicode: function () {

		var decreg = /^(&#|#)?([0-9][0-9]+);?$/;
		var decreg2 = /^(&#|#)([0-9]);?$/;
		var hexreg = /^(&#|#|0)?([xX])([0-9a-fA-F]+);?$/;

		/* Will track where the user last left off */
		var k = this.branch.getComplexValue("currstartset",
					Components.interfaces.nsIPrefLocalizedString).data;
		this.j = k;
		if (k < 0) {
			k = 1114112 + parseInt(k);
		}
		else if (k.toString().match(decreg)) { // Dec
			k = k.toString().replace(decreg, "$2");
			k = parseInt(k);
		}
		else if (k.toString().match(decreg2)) { // Dec
			k = k.toString().replace(decreg2, "$2");
			k = parseInt(k);
		}
		else if (k.toString().match(hexreg)) { // Hex
			k = k.toString().replace(hexreg, "$3");
			k = parseInt("0x"+k, 16);
		}
		else {
			// Convert toString in case trying to get the ASCII for a single digit number
			k = k.toString().charCodeAt(0);
		}

		if (k > 1114111) {
			k = 0;
		}
		else if (k < 0) { // could still be less than 0
			k += 1114112;
		}

		var rows = this.prefs.getIntPref("extensions.charrefunicode.tblrowsset");
		var cols = this.prefs.getIntPref("extensions.charrefunicode.tblcolsset");
		
		var inserttext = document.getElementById("inserttext");
		inserttext.setAttribute("rows", rows*20-10);
		inserttext.setAttribute("cols", cols*20-10);
	
		var hexyes = this.prefs.getBoolPref("extensions.charrefunicode.hexyes");
		var decyes = this.prefs.getBoolPref("extensions.charrefunicode.decyes");	
		var unicodeyes = this.prefs.getBoolPref("extensions.charrefunicode.unicodeyes");
		var middleyes = this.prefs.getBoolPref("extensions.charrefunicode.middleyes");
		
		var xstyle2 = this.prefs.getCharPref("extensions.charrefunicode.xstyle");

		if (middleyes) {
			k = k - ((rows * cols) / 2);
			if (k < 0) { // Could still be less than 0
				k += 1114112;
			}
		}

		var prev = k - (cols*rows);
		
		// Ensure 0-9 get treated as char. ref. values rather than Unicode digits
		if (prev >= 0 && prev <= 9) {
			prev = "'#"+prev+"'";
		}
		

		var tablecntnr = document.getElementById("tablecntnr");
		tablecntnr.textContent = '';
	
		
		var table = document.createElementNS(this.htmlns, "html:table");
		
		var caption = document.createElementNS(this.htmlns, "html:caption");
		caption.setAttribute("class", "dialogheader");
		
		table.setAttribute("class", "unicodetablecell");
	
		var captioncntnt = new Array();
		if (unicodeyes) {
			captioncntnt.push(this.strbundle.getString("unicode"));
		}
		if (hexyes) {
			captioncntnt.push(this.strbundle.getString("hexadecimal"));
		}
		if (decyes) {
			captioncntnt.push(this.strbundle.getString("decimal"));
		}
		
		var captcnt = captioncntnt[0];
	
		// Make first letter of first word upper case
		captcnt = captcnt.replace(/^([a-z])(.*)$/, 
			function(a, b, c){
				return b.toUpperCase()+c;
				}
			);
	
		// Build caption further
		for (var l = 1; l < captioncntnt.length-1; l++) {
			captcnt += this.strbundle.getString("comma")+" "+captioncntnt[l];
		}
		if (captioncntnt.length > 2) {
			captcnt += this.strbundle.getString("commaspaceand")+" "+captioncntnt[captioncntnt.length-1];
		}
		else if (captioncntnt.length === 2) {
			captcnt += " "+this.strbundle.getString("and")+" "+captioncntnt[captioncntnt.length-1];
		}
		
	
		caption.textContent = captcnt
	
		table.appendChild(caption);
		
		var tr, td, br, div, button;
		var buttonyes = this.prefs.getBoolPref("extensions.charrefunicode.buttonyes");
		for (var j = 0; j < rows; j++) {
	
			tr = document.createElementNS(this.htmlns, "html:tr");
	
			for (var i = 0; i < cols; i++) {
				td = document.createElementNS(this.htmlns, "html:td");
				td.setAttribute("class", "unicodetablecell");
				
				
				if (buttonyes) {
					button = document.createElementNS(this.htmlns, "html:input");
				}
				else {
					button = document.createElementNS(this.xulns, "label");
				}
				button.setAttribute("type", "button");
				button.setAttribute("name", "dec");
				button.setAttribute("id", "_" + this.idgen++);
				button.setAttribute("onclick", "Unicodecharref.insertText('inserttext', event.target.value);");
				
				
				if (decyes) {
					button.setAttribute("value", "&#"+k+";");
					if (!buttonyes) {
						var txtnd = document.createTextNode("&#"+k+";");
						button.appendChild(txtnd);
					}
					td.appendChild(button);
				}
				
				if (hexyes) {
					if (this.decyes) {
						var tn1 = document.createTextNode(" "+this.fixFromCharCode(160)+" ");
						td.appendChild(tn1);
					}
					
					if (buttonyes) {
						button = document.createElementNS(this.htmlns, "html:input");
					}
					else {
						button = document.createElementNS(this.xulns, "label");
					}
					button.setAttribute("type", "button");
					button.setAttribute("name", "hex");
					button.setAttribute("value", "&#"+xstyle2+k.toString(16)+';');
					if (!buttonyes) {
						var txtnd = document.createTextNode("&#"+xstyle2+k.toString(16)+';');
						button.appendChild(txtnd);
					}
					button.setAttribute("id", "_" + this.idgen++);
					button.setAttribute("onclick", "Unicodecharref.insertText('inserttext', event.target.value);");
					td.appendChild(button);
				}
	
				if (unicodeyes) {
					if (hexyes || decyes) {
						br = document.createElementNS(this.htmlns, "html:br");
						td.appendChild(br);
	
					}
					div = document.createElementNS(this.htmlns, "html:div");
					div.setAttribute("class", "centered");
					if (buttonyes) {
						button = document.createElementNS(this.htmlns, "html:input");
					}
					else {
						button = document.createElementNS(this.xulns, "label");
					}
					button.setAttribute("type", "button");
					button.setAttribute("name", "unicode");
					button.setAttribute("value", this.fixFromCharCode(k));
					if (!buttonyes) {
						var txtnd = document.createTextNode(this.fixFromCharCode(k));
						button.appendChild(txtnd);
					}
					button.setAttribute("id", "_" + this.idgen++);
					button.setAttribute("onclick", "Unicodecharref.insertText('inserttext', event.target.value);");
					div.appendChild(button);
					td.appendChild(div);
				}
				tr.appendChild(td);
				if (k >= 1114111) {
					k = 0;
				}
				else {
					k++;
				}
			}
			table.appendChild(tr);		
		}
	
		td = document.createElementNS(this.htmlns, "html:td");
		td.setAttribute("class", "centered");
		td.setAttribute("colspan", cols);
	
		var a = document.createElementNS(this.htmlns, "html:a");
		
		a.setAttribute("href", 
		  "javascript:Unicodecharref.k("+prev+");Unicodecharref.middleyes(false);Unicodecharref.printunicode();"
		);
		
		a.textContent = "Prev set";
	
		td.appendChild(a);
		
		var space = document.createTextNode(" "+this.fixFromCharCode(160)+" ");
		td.appendChild(space);
		
		var next = k;
		if (next >= 0 && next <= 9) {
			next = "'#"+next+"'";
		}
		
		a = document.createElementNS(this.htmlns, "html:a");
		a.setAttribute("href", 
		 "javascript:Unicodecharref.k("+next+");Unicodecharref.middleyes(false);Unicodecharref.printunicode();"
		);
		a.textContent = "Next set";
		td.appendChild(a);
	
	
		tr = document.createElementNS(this.htmlns, "html:tr");
		tr.appendChild(td);
	
		table.appendChild(tr);
		
		tablecntnr.appendChild(table);

/*  This was making the current preferences increment each time the window opened, even if it had not been changed
		var tempk = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		tempk.data = k;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  tempk);
*/	
		
		this.resizecells(false, null);
		
		window.sizeToContent();
	
	},

	insertText : function (id, evval) {

		var textarea = document.getElementById(id);
	

		var start = textarea.selectionStart;
		var end = textarea.selectionEnd;


		if (end > 0) {
			textarea.focus();
			var pre = textarea.value.substring(0, start);
	/* 	var selected = textarea.value.substring(start, end); */
			var post = textarea.value.substring(end, textarea.value.length);
	
			textarea.value = pre + evval + post;

			textarea.selectionStart = textarea.value.length - post.length;
			textarea.selectionEnd = textarea.value.length - post.length;
		}
		else {
// Although 	textarea.focus(); should be here (above the "if" actually), it seems to put the cursor at the beginning instead of end
// textarea.focus();
			textarea.value = textarea.value + evval;
			textarea.selectionStart = length;
			textarea.selectionEnd = length;
		}
		// Save values for manipulation by entity addition function, 'insertent'
		this.selst = textarea.selectionStart;
		this.selend = textarea.selectionEnd;
	
	},
	resizerowcols: function(id, rowcol, size) { // Changes size of convert textbox cols or rows
		var nsize = this.prefs.getIntPref("extensions.charrefunicode.rcsize."+id+"."+rowcol) + size;
		this.prefs.setIntPref("extensions.charrefunicode.rcsize."+id+"."+rowcol, nsize);
		document.getElementById(id).setAttribute(rowcol, nsize);
		window.sizeToContent();
	},
	fsizetextbox: function(size) { // Changes font-size
		var txtbxsize = this.prefs.getIntPref("extensions.charrefunicode.fsizetextbox");
		txtbxsize += size;
		this.prefs.setIntPref("extensions.charrefunicode.fsizetextbox", txtbxsize);

		document.getElementById("toconvert").style.fontSize = txtbxsize + "px";
		document.getElementById("converted").style.fontSize = txtbxsize + "px";
		if (size > 0) { // On Mac at least, resizing for reducing font size, causes button to 
				// go off screen
			window.sizeToContent();
		}
	},
	tblfontsize: function(size) { // Changes font-size of chart table cells
		var fsize = this.prefs.getIntPref("extensions.charrefunicode.tblfontsize") + size;
//		var tds = document.getElementsByTagNameNS(this.htmlns, "html:td");
		this.prefs.setIntPref("extensions.charrefunicode.tblfontsize", fsize);
		this.resizecells(true, size);
	},
	resizecells: function(windowrsz, size) {

		try {
			var xpathresultobj = document.evaluate(
													"//*[@name='dec' or @name='hex' or @name='unicode']", 
													/* contextNode */ document.documentElement, 
													/* Namespace URL mapping */ function() {return null}, 
													XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, 
													/* Same XPathResult object */ null);
		}
		catch (e) {
			alert(e);
		}

		for (var i = 0; i < xpathresultobj.snapshotLength; i++) {
			var tempid = xpathresultobj.snapshotItem(i);
		// This is apparently necessary as the XPath expression does not seem to me to be able to allow manipulation of the original node
			document.getElementById(tempid.id).style.fontSize = 
				this.prefs.getIntPref("extensions.charrefunicode.tblfontsize") + "px";
		}
		if (size > 0 && windowrsz) { // On Mac at least, resizing for reducing font size, causes button to 
				// go off screen
			window.sizeToContent();
		}
	},
	hexflip: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		
		this.setprefs(e);
		this.printunicode();
	},
	decflip: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		this.setprefs(e);
		this.printunicode();
	},
	unicodeflip: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		this.setprefs(e);
		this.printunicode();
	},
	middleflip: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		this.setprefs(e);
		this.printunicode();
	},
	xstyleflip: function() {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		var currxstyle = 'x';
		var prevxstyle = this.prefs.getCharPref("extensions.charrefunicode.xstyle");
		if (prevxstyle === 'x') {
			currxstyle = 'X';
		}
		this.prefs.setCharPref("extensions.charrefunicode.xstyle", currxstyle);
		this.printunicode();
	},
	buttonflip: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		this.setprefs(e);
		this.printunicode();
	},
	rowsset: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		if (e.target.value != null && e.target.value != '') {
			this.prefs.setIntPref("extensions.charrefunicode.tblrowsset", e.target.value);
		}
		this.printunicode();
	},
	colsset: function(e) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = this.j;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
		if (e.target.value != null && e.target.value != '') {
			this.prefs.setIntPref("extensions.charrefunicode.tblcolsset", e.target.value);
		}
		this.printunicode();
	},
	startset: function(e) {
		if (e.target.value != null && e.target.value != '') {
			var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
			temp1.data = e.target.value;
			this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
			
		}
		else {

			/* Only used when the field is manually changed to blank (default start set) */						
			var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                    .createInstance(Components.interfaces.nsIPrefLocalizedString);
			temp1.data = this.branch.getComplexValue("startset",
					Components.interfaces.nsIPrefLocalizedString).data;
			this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                      Components.interfaces.nsIPrefLocalizedString, 
					  temp1);
						
		}
		this.printunicode();
	},
	doOK: function () {
		this.prefs.setIntPref("extensions.charrefunicode.window.outer.height", window.outerHeight);
		this.prefs.setIntPref("extensions.charrefunicode.window.outer.width", window.outerWidth);
		return false;
	},

	doCancel: function (){
		return true;
	},
	moveoutput: function(movedid){
		var inserttext = document.getElementById(movedid);
		document.getElementById("unicodetabpanels").selectedIndex = 0;
		document.getElementById("unicodetabs").selectedIndex = 0;
		document.getElementById("toconvert").value = inserttext.value;
	},
	append2htmlflip: function(e) {
		this.setprefs(e);
		this.registerDTD(); // (in case DTD not also changed, still need to reset)
	},
	registerDTD: function() {
	
		// Cannot use back-reference inside char. class, so need to do twice
		var pattern = /<!ENTITY\s+([^'"\s]*)\s+(["'])(.*)\2\s*>/g;
		
		var text = document.getElementById("DTDtextbox").value;
		
		var temp0 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                   .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp0.data = text;
		this.prefs.setComplexValue("extensions.charrefunicode.DTDtextbox", 
                  Components.interfaces.nsIPrefLocalizedString, 
				  temp0);		
		
		var result;
		
		
		// Reset in case charrefs or ents array deleted before and now want to go back to their original values.
		if (this.prefs.getBoolPref("extensions.charrefunicode.appendtohtmldtd")) {
			this.copyarray(this.origents, this.ents);
			this.copyarray(this.origcharrefs, this.charrefs);
		}
		else {
			this.ents = new Array();
			this.charrefs = new Array();
		}
		
		this.copyarray(this.orignewents, this.newents); // Start off blank in case items erased
		this.copyarray(this.orignewcharrefs, this.newcharrefs); // Start off blank in case items erased
				
		while((result = pattern.exec(text)) != null) {
			
			var decreg = /^(&#)([0-9]+);$/;
			var hexreg = /^(&#[xX])([0-9a-fA-F]+);$/;
			var m = result[3];

			var addreg = true;
			if (m.match(decreg)) { // Dec
				m = m.replace(decreg, "$2");
				m = parseInt(m);
			}
			else if (m.match(hexreg)) { // Hex
				m = m.replace(hexreg, "$2");
				m = parseInt("0x"+m, 16);
			}
			else if (m.length > 1) { // If replacing with Unicode sequence longer than one character, assume only wish to convert from entity (not from Unicode)
				addreg = false;
			}
			else {
				m = m.charCodeAt(0);
			}
			if (addreg) {
				this.shiftcount += 1; // Used to ensure apos or amp is detected in same position
				this.ents.unshift(result[1]);
				this.charrefs.unshift(m);
			}
			else { // For translating entities into two-char+ Unicode, or hex or dec
				this.newents.push(result[1]);
				this.newcharrefs.push(m); // Can be a string, etc.
			}
		}
	},
	middleyes : function(bool) {
		// Commented this out because while it will always change (unlike now), the value will be misleading
		// document.getElementById("extensions.charrefunicode.middleyes").checked = bool;
		this.prefs.setBoolPref("extensions.charrefunicode.middleyes", bool);
	},
	/* Some of these defaults may become irrelevant due to the /default/preferences/charrefunicode.js file's settings */
	k: function(setval) {
		var temp1 = Components.classes["@mozilla.org/pref-localizedstring;1"]
                   .createInstance(Components.interfaces.nsIPrefLocalizedString);
		temp1.data = setval;
		this.prefs.setComplexValue("extensions.charrefunicode.currstartset", 
                  Components.interfaces.nsIPrefLocalizedString, 
				  temp1);		
	},
	insertent: function(id) {
		textarea = document.getElementById(id);
		this.insertText(id, '<!ENTITY  "">\n');
		/* The following works but may be annoying if trying to insert multiple entities at a time (thus the addition of the newline)
		// Bring cursor back a little
		textarea.selectionStart = this.selst - 5;
		textarea.selectionEnd = this.selend - 5;
		*/
	},
	shiftcount: 0,
	idgen: 0,
	prefs: null,
	newents: new Array(),
	newcharrefs: new Array(),

	/* Pseudo-constants */
	// If one ever changes this array, one will cause problems for the script, as it is expected to find "apos" in position 98--adjusted for any additions to the front by the user DTD (and the next array also corresponds to this one; if ever change this array (besides adding to the end of it), will need to change the "98" references above as well as adjust the charrefs array to match the correspondence with this one
	ents : new Array("nbsp","iexcl","cent","pound","curren","yen","brvbar","sect","uml","copy","ordf","laquo","not","shy","reg","macr","deg","plusmn","sup2","sup3","acute","micro","para","middot","cedil","sup1","ordm","raquo","frac14","frac12","frac34","iquest","Agrave","Aacute","Acirc","Atilde","Auml","Aring","AElig","Ccedil","Egrave","Eacute","Ecirc","Euml","Igrave","Iacute","Icirc","Iuml","ETH","Ntilde","Ograve","Oacute","Ocirc","Otilde","Ouml","times","Oslash","Ugrave","Uacute","Ucirc","Uuml","Yacute","THORN","szlig","agrave","aacute","acirc","atilde","auml","aring","aelig","ccedil","egrave","eacute","ecirc","euml","igrave","iacute","icirc","iuml","eth","ntilde","ograve","oacute","ocirc","otilde","ouml","divide","oslash","ugrave","uacute","ucirc","uuml","yacute","thorn","yuml","quot","gt","apos","amp","lt","OElig","oelig","Scaron","scaron","Yuml","circ","tilde","ensp","emsp","thinsp","zwnj","zwj","lrm","rlm","ndash","mdash","lsquo","rsquo","sbquo","ldquo","rdquo","bdquo","dagger","Dagger","permil","lsaquo","rsaquo","euro","fnof","Alpha","Beta","Gamma","Delta","Epsilon","Zeta","Eta","Theta","Iota","Kappa","Lambda","Mu","Nu","Xi","Omicron","Pi","Rho","Sigma","Tau","Upsilon","Phi","Chi","Psi","Omega","alpha","beta","gamma","delta","epsilon","zeta","eta","theta","iota","kappa","lambda","mu","nu","xi","omicron","pi","rho","sigmaf","sigma","tau","upsilon","phi","chi","psi","omega","thetasym","upsih","piv","bull","hellip","prime","Prime","oline","frasl","weierp","image","real","trade","alefsym","larr","uarr","rarr","darr","harr","crarr","lArr","uArr","rArr","dArr","hArr","forall","part","exist","empty","nabla","isin","notin","ni","prod","sum","minus","lowast","radic","prop","infin","ang","and","or","cap","cup","int","there4","sim","cong","asymp","ne","equiv","le","ge","sub","sup","nsub","sube","supe","oplus","otimes","perp","sdot","lceil","rceil","lfloor","rfloor","lang","rang","loz","spades","clubs","hearts","diams"),
	charrefs : new Array(160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,34,62,39,38,60,338,339,352,353,376,710,732,8194,8195,8201,8204,8205,8206,8207,8211,8212,8216,8217,8218,8220,8221,8222,8224,8225,8240,8249,8250,8364,402,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,977,978,982,8226,8230,8242,8243,8254,8260,8472,8465,8476,8482,8501,8592,8593,8594,8595,8596,8629,8656,8657,8658,8659,8660,8704,8706,8707,8709,8711,8712,8713,8715,8719,8721,8722,8727,8730,8733,8734,8736,8743,8744,8745,8746,8747,8756,8764,8773,8776,8800,8801,8804,8805,8834,8835,8836,8838,8839,8853,8855,8869,8901,8968,8969,8970,8971,9001,9002,9674,9824,9827,9829,9830),

	/* Constants */
	xulns : "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
	htmlns : "http://www.w3.org/1999/xhtml",
	decim : /&#([0-9]*);/g ,
	hexadec : /&#[xX]([0-9a-fA-F]*);/g ,
	htmlent : /&([_a-zA-Z][-0-9_a-zA-Z]*);/g /* Unicode complete version? */
	
}